\documentclass[a4paper, trou]{tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}
\input{macro}
\input{tpl/listing-config}

  
\graphicspath{{tpl/}{img/}}
\ddmodulename{Informatique}
\ddmodulenumber{Machine learning}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien




\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  

\newdnnexo{03}{Converging rate, error and epoch}

\noindent
Let's interested us to the error that appears during the learning process and how
the Perceptron algorithm converges toward a solution.


\section*{Cumulative error implementation}
The graph below
plots the data and the cumulative errors made during the learning
process. \textit{Cumulative errors} means that each time the
Perceptron gives the wrong answer during the learning process, the
related error increments its value of one. Here, the cumulative error
is a measure of the learning process rate of the machine.
\begin{center}
  \svg{1.\linewidth}{./img/perceptron-converge-good.pdf_tex}
\end{center}


\begin{manip}
  Thanks to the first tutorial, create a Python environment \texttt{(dnn)} and launch the \textbf{thonny} editor.
\end{manip}

\begin{manip}
  Download the
  \href{https://gitlab.com/damien.andre/learning-python-for-science/blob/master/script/dnn/mltool.py}{\texttt{mltool.py}} 
  file and put it in your current working dir.
\end{manip}

\begin{manip}
  Download the \dltutodnn{03}{tuto-03.py} script file and
  execute it with \textbf{thonny}. This file will be used as starting point for
  this tutorial.
\end{manip}

\begin{task}
  From the initial script, implement the cumulative error calculation
  during the learning step. Plot the evolution of cumulative error
  during the learning step.
\end{task}

\begin{info}
  The correction of this part is given by \dltutodnn{03}{tuto-03\_correction-part1.py}
\end{info}

\section*{Overlapping data}
In this above case, the Perceptron made only one mistake on the whole
1,000 data sample and the result looks really good. In fact, this good
result is given because data are easily linearly separable. Let's see a
more complicated example with an overlapping zone between the two
classes as shown below.
\begin{center}
  \svg{1.\linewidth}{./img/perceptron-converge-bad.pdf_tex}
\end{center}
In this new sample, an overlapping zone exists and the data are not
clearly linearly separable. As, you can see, the results given by the
Perceptron is bad because the separated line is not well placed. This
bad result is also highlighted on the cumulative errors evolution that
rises up continuously.

\begin{info}
  Now, you will work on this special dataset.
\end{info}

\begin{manip}
  Download the \dltutodnn{03}{data.txt} and the \dltutodnn{03}{label.txt} files which contain this dataset.
\end{manip}

\begin{task}
  Load this dataset into your script file thanks to the following code snippet :
  \vspace*{-1.5\baselineskip}
\begin{lstlisting}
# load the data from files
data = np.loadtxt("data.txt")
label = np.loadtxt("label.txt").astype(int)
\end{lstlisting}
  You should obtain the above figure.
\end{task}

\begin{info}
  The correction of this part is given by \dltutodnn{03}{tuto-03\_correction-part2.py}
\end{info}


\section*{Let's do it again: the epoch}

In order to minimize this error, let's try to
pass again the whole data sample into the learning process. The number
of loop where the whole data sample are processed in the learning process
is called \textbf{epoch}.


\begin{task}
  Implement a script with 100 epochs. You should obtain something like this.
  \begin{center}
  \svg{1.\linewidth}{./img/perceptron-converge-bad-100-epoch.pdf_tex}
\end{center}
\end{task}

\begin{info}
  The correction of this part is given by \dltutodnn{03}{tuto-03\_correction-part3.py}
\end{info}


\section*{Conclusion}
As you can see, the results is quiet better: the frontier between the
two classes looks better than the previous one with one epoch.  


However, as you can see on the previous graphs, the cumulative error seems to
linearly increase and do not stabilize toward a single value. This is
expected, because as you can see on the previous figure some points are
misclassified. It generates single errors that accumulate and induce a
regular increase of the cumulative error curve. In fact, in this special
case, the data are not fully linearly separable. That's why these errors are
unavoidable.

The next tutorial step will give some tips to deal with this unavoidable errors.



\end{document}
